;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

    null EQU NULL

;==============================================================================
    .data

      hInst       dd          0
      hWnd        dd          0

      posx        dd          0
      posy        dd          0

      hwndStatic1 dd          0
      hwndStatic2 dd          0
      hwndStatic3 dd          0
      hwndStatic4 dd          0
      hwndStatic5 dd          0

      wcx         WNDCLASSEX  <>
      msg         MSG         <>
      className   db          "test_class",0

    .code
;==============================================================================

WindowProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

        CASE WM_CREATE

            STYLE = WS_CHILD or WS_VISIBLE or SS_CENTER

            invoke CreateWindowEx, WS_EX_CLIENTEDGE,
                                   chr$("STATIC"),
                                   chr$("XXXXX"),
                                   STYLE,
                                   20,
                                   20,
                                   150,
                                   30,
                                   hWin,
                                   1001,
                                   hInst,
                                   null

            mov hwndStatic1, eax

            STYLE = WS_CHILD or WS_VISIBLE or SS_CENTER or SS_SUNKEN

            invoke CreateWindowEx, 0,
                                   chr$("STATIC"),
                                   chr$("XXXXX"),
                                   STYLE,
                                   20,
                                   70,
                                   150,
                                   30,
                                   hWin,
                                   1002,
                                   hInst,
                                   null

            mov hwndStatic2, eax

            STYLE = WS_CHILD or WS_VISIBLE or SS_CENTER or SS_SUNKEN

            invoke CreateWindowEx, WS_EX_CLIENTEDGE,
                                   chr$("STATIC"),
                                   chr$("XXXXX"),
                                   STYLE,
                                   20,
                                   120,
                                   150,
                                   30,
                                   hWin,
                                   1003,
                                   hInst,
                                   null

            mov hwndStatic3, eax

            STYLE = WS_CHILD or WS_VISIBLE or SS_CENTER

            invoke CreateWindowEx, WS_EX_CLIENTEDGE,
                                   chr$("STATIC"),
                                   chr$("XXXXX"),
                                   STYLE,
                                   20,
                                   170,
                                   150,
                                   30,
                                   hWin,
                                   1004,
                                   hInst,
                                   null

            mov hwndStatic4, eax

            STYLE = WS_CHILD or WS_VISIBLE or SS_CENTER

            invoke CreateWindowEx, WS_EX_CLIENTEDGE,
                                   chr$("STATIC"),
                                   chr$("XXXXX"),
                                   STYLE,
                                   20,
                                   220,
                                   150,
                                   30,
                                   hWin,
                                   1004,
                                   hInst,
                                   null

            mov hwndStatic5, eax

        CASE WM_CTLCOLORSTATIC

            SWITCH lParam

                CASE hwndStatic4

                    ;--------------------------------------------------
                    ; Set the text color, get a stock brush (that does
                    ; not need to be deleted when whe finish with it),
                    ; and return the handle of the brush.
                    ;--------------------------------------------------

                    invoke SetTextColor, wParam, 0000ffh
                    invoke GetStockObject, WHITE_BRUSH
                    ret

                CASE hwndStatic5

                    ;----------------------------------------------------
                    ; Here we use a null brush so the control background
                    ; will not be filled and set the background mix mode
                    ; so the background for the text will not be filled
                    ; (with the current background color) before the
                    ; text is drawn.
                    ;----------------------------------------------------

                    invoke SetTextColor, wParam, 0ff0000h
                    invoke SetBkMode, wParam, TRANSPARENT
                    invoke GetStockObject, NULL_BRUSH
                    ret

            ENDSW

        CASE WM_COMMAND

            ;-----------------------------------------------------------
            ; Allow the user to close the window by pressing the escape
            ; key. This method will work only if the message loop uses
            ; IsDialogMessage to process the messages.
            ;-----------------------------------------------------------

            .if wParam == IDCANCEL
                invoke DestroyWindow, hWin
            .endif

        CASE WM_CLOSE

            invoke DestroyWindow, hWin

        CASE WM_DESTROY

            invoke PostQuitMessage, NULL
            return 0

        DEFAULT

            invoke DefWindowProc, hWin, uMsg, wParam, lParam
            ret

    ENDSW

    return 0

WindowProc endp

;==============================================================================
start:
;==============================================================================

    mov   hInst, rv(GetModuleHandle, NULL)
    mov   wcx.cbSize,        sizeof WNDCLASSEX
    mov   wcx.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov   wcx.lpfnWndProc,   offset WindowProc
    mov   wcx.cbClsExtra,    NULL
    mov   wcx.cbWndExtra,    NULL
    m2m   wcx.hInstance,     hInst
    mov   wcx.hbrBackground, COLOR_BTNFACE + 1
    mov   wcx.lpszMenuName,  NULL
    mov   wcx.lpszClassName, offset className
    mov   wcx.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov   wcx.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov   wcx.hIconSm,       0

    invoke RegisterClassEx, addr wcx

    ;--------------------------------------------------------------
    ; Specify the window width and height and calc the coordinates
    ; necessary to center the window on the screen.
    ;--------------------------------------------------------------

    WW = 200
    WH = 300
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, WW / 2
    mov posx, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    shr eax, 1
    sub eax, WH / 2
    mov posy, eax

    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            addr className,
                            chr$("Test"),
                            WS_OVERLAPPED or WS_SYSMENU,
                            posx, posy, WW, WH,
                            null, null,
                            null, null
    mov   hWnd, eax

    invoke ShowWindow, hWnd, SW_SHOWDEFAULT
    invoke UpdateWindow, hWnd

  msgLoop:

    invoke GetMessage, addr msg, NULL, 0, 0
    .if eax != 0
        invoke IsDialogMessage, hWnd, addr msg
        .if eax == 0
            invoke TranslateMessage, addr msg
            invoke DispatchMessage, addr msg
        .endif
        jmp   msgLoop
    .ENDIF

    exit msg.wParam

;==============================================================================
end start
